import java.util.*;
public class Main_Class {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*these store input and output to queues. they should be the same after
		everything has been enqueued and then dequeued */
		ArrayList<Object> inputs = new ArrayList<Object>();  /* enqueued objects */
		ArrayList<Object> outputs = new ArrayList<Object>(); /* dequeued objects*/
		
		/* test the linked list queue implementation */
		System.out.println("******** test Linked List queue ***********");
		LinkedList_queue test_queue = new LinkedList_queue();
		System.out.println("initial Linked List queue size: "+test_queue.size());
		for(int i = 0; i < 10; i++){
			Integer iobj = new Integer(i);
			Integer record = new Integer(iobj);
			test_queue.enqueue(iobj);
			inputs.add(record);
		}
		System.out.println("final Linked List queue size: "+test_queue.size());
		while( ! test_queue.isEmpty()){
			outputs.add(test_queue.dequeue());
		}
		System.out.println("items enqueued" + inputs.toString());
		System.out.println("items dequeued" + outputs.toString());
		System.out.println("Linked List queue size: "+test_queue.size());
		
		/* test the array based queue */
		inputs.clear(); outputs.clear();
		System.out.println("********** test array based queue ***********");
		Array_queue test_queue2 = new Array_queue(12);
		System.out.println("initial Array queue size: "+test_queue2.size());
		for(int i = 0; i < 12; i++){
			Integer iobj = new Integer(i);
			Integer record = new Integer(iobj);
			test_queue2.enqueue(iobj);
			inputs.add(record);
		}
		System.out.println("final Array queue size: "+test_queue2.size());
		while( ! test_queue2.isEmpty()){
			outputs.add(test_queue2.dequeue());
		}
		System.out.println("items enqueued" + inputs.toString());
		System.out.println("items dequeued" + outputs.toString());
		System.out.println("Array queue size: "+test_queue2.size());
	}

}
